import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.util.*;

import Solver;

public final class Simple extends Applet implements MouseListener, ItemListener {
/*External tools*/
	Solver solv = new Solver();
/*Oletuslauseke*/
	String init_exp ="t^2-y^2";
/*Nappien vri, Linux tuntuu tarvitsevan tt*/
	Color nappi = Color.lightGray;
/*Kyrien vrirotaation alkuarvo*/
	int rotaatio = 0;
/*Alkuarvot kooordinaatiston skaalalle*/
	double tmin = -4.0;
	double tmax = 4.0;
	double ymin = -4.0;
	double ymax = 4.0;
/*Laskennassa paljon kytetyt koordinaatiston leveys ja korkeus valmiiksi laskettuna*/
	double tleveys = tmax-tmin;
	double yleveys = ymax-ymin;
/*Tietorakenne, johon tallennetaan lasketut kyrt*/
	Vector kayrat = new Vector();
/*Kyr pidetn muistissa polygonimuodossa*/
	Polygon kayra = new Polygon();
/*Oletusaskelpituus ei-adaptiivisille laskentamenetelmille*/
	double askelpituus = 0.1;
/*Koordinaatiston leveys ja reunus pikselein*/
	int leveys = 350;
	int reunus = 25;
/*Kyttliittymn komponentit*/
	Piirtoalusta paperi = new Piirtoalusta();
	Font otsikkofontti = new Font("Serif",Font.BOLD,12);
	Panel pap = new Panel(new BorderLayout());
	Panel oikea = new Panel(new GridLayout(4,1));
	Panel alkuarvot = new Panel(new BorderLayout());
	Label alkuarvoteksti = new Label("Initial values");	
	Panel alkuarvosisus = new Panel(new GridLayout(2,2));
	Label alkuarvo_t_on = new Label("t = ",Label.RIGHT);
	Label alkuarvo_y_on = new Label("y = ",Label.RIGHT);
	TextField tsyote = new TextField(11);
	TextField ysyote = new TextField(11);
	Button piirra = new Button("Draw");
	Panel yhtalo = new Panel(new BorderLayout());
	Label yhtaloteksti = new Label("Equation");	
	Panel yhtalosisus = new Panel(new BorderLayout());
	Label ypilkku = new Label("y' = ",Label.RIGHT);
	Panel luefunraami = new Panel(new GridLayout(2,1));
	Choice esimerkki = new Choice();		
	TextField funktio = new TextField();
	Button lueyht= new Button("Read equation");
	Panel asteikkoraami = new Panel(new BorderLayout());
	Label asteikkoteksti = new Label("Scale");
	Panel asteikkosisus = new Panel(new GridLayout(2,4));
	Label tmins = new Label("tmin : ",Label.RIGHT);
	Label tmaxs = new Label("tmax : ",Label.RIGHT);
	Label ymins = new Label("ymin : ",Label.RIGHT);
	Label ymaxs = new Label("ymax : ",Label.RIGHT);
	TextField tminsyote = new TextField();
	TextField tmaxsyote = new TextField();
	TextField yminsyote = new TextField();
	TextField ymaxsyote = new TextField();
	Button asteikko=new Button("Change scale");
	Panel oikeaala = new Panel(new BorderLayout());
	Label oikeaalateksti = new Label("General");
	Choice algoritmi = new Choice();
	Label askelteksti = new Label("Stepsize = ",Label.RIGHT);
	Panel algoritmiraami = new Panel(new GridLayout(2,1));
	TextField askel = new TextField();
	Panel askelraami = new Panel(new BorderLayout());
	Button siivoa=new Button("Clear");
	TextField lue2 = new TextField(12);
	Panel yleiset = new Panel(new GridLayout(1,2));
	Panel otsikko = new Panel(new BorderLayout());
	Label phase_plane = new Label("Direction field");
	Label copyright = new Label("20.03.2001  Mika Spra, Simo Kivel @ Institute of Mathematics of Helsinki University of Technology",Label.CENTER);

	public final void init() {
/*Kyttliittymn alustaminen*/
		setBackground(new Color(204,204,255));
		funktio.setText(init_exp);
		paperi.setBackground(Color.white);
		lue2.setEditable(false);
		tminsyote.setText(""+tmin);
		tmaxsyote.setText(""+tmax);
		yminsyote.setText(""+ymin);
		ymaxsyote.setText(""+ymax);
		paperi.setSize(leveys+50,leveys+50);
		add(pap);
		otsikko.add("North",phase_plane);;
		otsikko.add("Center", paperi);
		phase_plane.setFont(otsikkofontti);
		pap.add("Center", otsikko);
		alkuarvoteksti.setFont(otsikkofontti);
		alkuarvot.add("North",alkuarvoteksti);
		alkuarvosisus.add(alkuarvo_t_on);
		alkuarvosisus.add(tsyote);
		alkuarvosisus.add(alkuarvo_y_on);
		alkuarvosisus.add(ysyote);
		alkuarvot.add("Center",alkuarvosisus);
		piirra.setBackground(nappi);
		alkuarvot.add("South",piirra);
		oikea.add(alkuarvot);
		yhtaloteksti.setFont(otsikkofontti);
		yhtalo.add("North",yhtaloteksti);
		yhtalosisus.add("West",ypilkku);
		esimerkki.setBackground(nappi);
		luefunraami.add(esimerkki);
		luefunraami.add(funktio);
		yhtalosisus.add("Center",luefunraami);
		yhtalo.add("Center",yhtalosisus);
		lueyht.setBackground(nappi);
		yhtalo.add("South",lueyht);
		oikea.add(yhtalo);
		asteikkoteksti.setFont(otsikkofontti);
		asteikkoraami.add("North",asteikkoteksti);
		asteikkosisus.add(tmins);
		asteikkosisus.add(tminsyote);
		asteikkosisus.add(tmaxs);
		asteikkosisus.add(tmaxsyote);
		asteikkosisus.add(ymins);
		asteikkosisus.add(yminsyote);
		asteikkosisus.add(ymaxs);
		asteikkosisus.add(ymaxsyote);
		asteikkoraami.add("Center",asteikkosisus);
		asteikko.setBackground(nappi);
		asteikkoraami.add("South",asteikko);
		oikea.add(asteikkoraami);
		oikeaalateksti.setFont(otsikkofontti);
		oikeaala.add("North",oikeaalateksti);
		algoritmi.setBackground(nappi);
		algoritmiraami.add(algoritmi);
		askelraami.add("West",askelteksti);
		askelraami.add("Center",askel);
		algoritmiraami.add(askelraami);
		oikeaala.add("Center",algoritmiraami);
		siivoa.setBackground(nappi);
		yleiset.add(siivoa);
		lue2.setBackground(nappi);
		yleiset.add(lue2);
		oikeaala.add("South",yleiset);
		oikea.add(oikeaala);
		pap.add("East",oikea);
		pap.add("South",copyright);
		lue2.setBackground(Color.lightGray);
		tsyote.setText("0");
		ysyote.setText("0");
		askel.setBackground(nappi);
		askel.setText("");
		askel.setEditable(false);
		solv.parser(init_exp);
/*Tapahtumakuuntelijoiden asettaminen*/
	 	paperi.addMouseListener(this);
		siivoa.addMouseListener(this);
		asteikko.addMouseListener(this);
		lueyht.addMouseListener(this);
		piirra.addMouseListener(this);
		esimerkki.addItemListener(this);
		algoritmi.addItemListener(this);
/*Valmiit esimerkit*/
		esimerkki.add("Choose");
		esimerkki.add("t^2-y^2");
		esimerkki.add("2*abs(y)");
		esimerkki.add("(t+y)/(t-y)");
		esimerkki.add("-(3*t^2+6*t*y^2)/(6*t^2*y+4*y^3)");
/*Ohjelmoidut menetelmt*/
		algoritmi.add("Adaptive Runge-Kutta");
		algoritmi.add("Euler");
		algoritmi.add("Improved Euler");
		algoritmi.add("Runge-Kutta");
		algoritmi.add("Adams-Bashforth");
	}

/*Vrirotaatio*/
	public final Color annaVari() {
		Color varivast = Color.black;
		switch (rotaatio) {
		case 0:
			varivast = Color.blue;
			break;		
		case 1:
			varivast = Color.green.darker();
			break;		
		case 2:
			varivast = Color.red;
			break;		
		case 3:
			varivast = Color.magenta;
			break;		
		case 4:
			varivast = Color.black;
			rotaatio = -1;
			break;
		}		
		rotaatio++;
	return varivast;
	}

/*Netscapea verten appletti nukutetaan ennen tuhoamista*/
 	public final void destroy() {
		try {
			Thread.sleep(2000);
	    	} 
		catch(InterruptedException ex) {
	    	}
	}

/*Esimerkkien ja algoritmin valinta tiputusvalikoista*/
	public final void itemStateChanged(ItemEvent e) {
 		if (esimerkki.getSelectedItem() != "Choose") 
			funktio.setText(esimerkki.getSelectedItem());
		esimerkki.select(0);
		if (algoritmi.getSelectedIndex() == 0){
			askel.setBackground(nappi);
			askel.setText("");
			askel.setEditable(false);
		}
		else {
			askel.setBackground(Color.white);
			askel.setText(""+askelpituus);
			askel.setEditable(true);
		}
	}

/*Hiirenksittely*/
	public final void mousePressed(MouseEvent tapahtuma){}
	public final void mouseEntered(MouseEvent tapahtuma){}
	public final void mouseClicked(MouseEvent tapahtuma){}
	public final void mouseReleased(MouseEvent tapahtuma) {
		lue2.setText("Wait");
		double ttesti = 0;
		double ytesti = 0;
		boolean ok = true;
/*Piirtoalustan klikkaaminen*/
		if (tapahtuma.getComponent() == paperi) {
			double xtemp = xMuutosruudulta(tapahtuma.getX());
			double ytemp = yMuutosruudulta(tapahtuma.getY());
			tsyote.setText(""+xtemp);
			ysyote.setText(""+ytemp);
			suoritaPiirto(xtemp,ytemp);
			lue2.setText("Ready");
		}
/*Draw-nappi*/
		else if (tapahtuma.getComponent() == piirra) {
			try {
				ttesti=new Double(tsyote.getText()).doubleValue();
				ytesti=new Double(ysyote.getText()).doubleValue();
			}
			catch (Exception e) {
				ok = false;
			}
			if (ok) {
				suoritaPiirto(ttesti,ytesti);
				lue2.setText("Ready");
			}
			else {
				getToolkit().beep();
				lue2.setText("Bad values");
			}
		}
/*Clear-nappi*/
		else if (tapahtuma.getComponent() == siivoa) {
			kayrat.removeAllElements();
			funktio.setText(solv.exp_orig);
			rotaatio = 0;
			paperi.repaint();
		}
/*Change scale-nappi*/
		else if (tapahtuma.getComponent() == asteikko) {
			asteikkoMuutos();
		}
/*Read equation-nappi*/
		else if (tapahtuma.getComponent() == lueyht) {
			if (solv.parser(funktio.getText())) {
				kayrat.removeAllElements();
				rotaatio=0;
				paperi.repaint();
				lue2.setText("Ready");
			}
			else {
				getToolkit().beep();
				lue2.setText(""+solv.error_msg);
			}
		}
	}
	public final void mouseExited(MouseEvent tapahtuma){}

/*Koordinaatistomuutokset nytlt laskentaan ja pinvastoin*/
	public final double xMuutosruudulta(int ruutux) {
		double oikeax;
		oikeax = tmin+((tleveys)/leveys)*(ruutux-reunus);
		return oikeax;
	}

	public final double yMuutosruudulta(int ruutuy) {
		double oikeay;
		oikeay = ymin+((yleveys)/leveys*(leveys-ruutuy+reunus));
		return oikeay;
	}

	public final int xMuutosruudulle(double oikeax) {
		int ruutux;
		ruutux = ((int)(reunus+(leveys*(oikeax-tmin)/(tleveys))));
		return ruutux;
	}

	public final int yMuutosruudulle(double oikeay) {
		int ruutuy;
		ruutuy = ((int)(reunus+leveys-(leveys*(oikeay-ymin)/(yleveys))));
		return ruutuy;
	}

/*Asteikon skaalan muuttaminen*/
	public final void asteikkoMuutos() {
		boolean ok = true;
		double testi;
		try {
			testi=new Double(tminsyote.getText()).doubleValue();
		}
		catch (Exception e) {
			ok = false;
		}
			
		try {
			testi=new Double(tmaxsyote.getText()).doubleValue();
		}
		catch (Exception e) {
			ok = false;
		}

		try {
			testi=new Double(yminsyote.getText()).doubleValue();
		}
		catch (Exception e) {
			ok = false;
		}

		try {
			testi=new Double(ymaxsyote.getText()).doubleValue();
		}
		catch (Exception e) {
			ok = false;
		}
		if (ok && (new Double(tminsyote.getText()).doubleValue() < new Double(tmaxsyote.getText()).doubleValue()) && (new Double(yminsyote.getText()).doubleValue()< new Double(ymaxsyote.getText()).doubleValue())) {
			tmin=new Double(tminsyote.getText()).doubleValue();
			tmax=new Double(tmaxsyote.getText()).doubleValue();
			ymin=new Double(yminsyote.getText()).doubleValue();
			ymax=new Double(ymaxsyote.getText()).doubleValue();
			tleveys = tmax-tmin;
			yleveys = ymax-ymin;
			kayrat.removeAllElements();
			paperi.repaint();
		}

		else {
			lue2.setText("Bad values");
			getToolkit().beep();
		}
		tminsyote.setText(""+tmin);
		tmaxsyote.setText(""+tmax);
		yminsyote.setText(""+ymin);
		ymaxsyote.setText(""+ymax);
	}

/*Piirtorutiini uuden kyrn piirtmiseksi annetuilla alkuarvoilla*/
	public final void suoritaPiirto(double t, double y)
	{
		solv.error=false;
		Graphics g = paperi.getGraphics();
		g.setColor(annaVari());
		g.drawOval(xMuutosruudulle(t)-5,yMuutosruudulle(y)-5,10,10);
		pisteet(t,y,tmax);
		kayrat.addElement(kayra);
		g.drawPolyline(kayra.xpoints,kayra.ypoints,kayra.npoints);
		pisteet(t,y,tmin);
		kayrat.addElement(kayra);
		g.drawPolyline(kayra.xpoints,kayra.ypoints,kayra.npoints);
	}

/*Kynnistetn oikea laskentarutiini kyrn pisteiden laskemiseksi*/
	public final void pisteet(double t0, double y0, double thuippu) {
		int laskalg = algoritmi.getSelectedIndex();
		switch (laskalg) {
			case 0 : 
				adaptive(t0,y0,thuippu);
				break;
			case 1 :
				euler(t0, y0, thuippu);
				break;
			case 2 :
				pareuler(t0, y0, thuippu);
				break;
			case 3 :
				rungekutta(t0, y0, thuippu);
				break;
			case 4 :
				adamsbashforth(t0, y0, thuippu);
				break;
		}
	}
/*Eulerin memetelm*/
	public final void euler(double t0, double y0, double thuippu) {
		double htemp=0;
		double[] y = new double[1];
		double t = t0;
		int suunta = 1;
		y[0]= y0;
		boolean askelok = true;
		try {
			htemp=new Double(askel.getText()).doubleValue();
		}
		catch (Exception e) {
			askelok = false;
		}
		if (askelok) askelpituus = htemp;
		double h = askelpituus;
		if ((thuippu - t0) < 0) {
			h = -h;
			suunta = -1;
		}
		kayra = new Polygon();
		kayra.addPoint(xMuutosruudulle(t0),yMuutosruudulle(y0));
		while ((suunta*(thuippu-t) > 0) && solv.error == false) {
			y[0] += h*solv.evaluate(t, y)[0];
			t += h;
			if (solv.error == false) {
				if (y[0] < 2*yleveys && y[0] > 2*(-yleveys)){
					kayra.addPoint(xMuutosruudulle(t),yMuutosruudulle(y[0]));
				}
				else solv.error = true;
			}
		}
		solv.error = false;
	}
/*Parannettu Eulerin menetelm*/
	public final void pareuler(double t0, double y0, double thuippu) {
		double htemp=0;
		double[] y = new double[1];
		double[] sij = new double[1];
		y[0]= y0;

		double t = t0;
		int suunta = 1;
		boolean askelok = true;
/*Lue askelpituus, kyt oletusta, jos syte on huono*/
		try {
		htemp=new Double(askel.getText()).doubleValue();
		}
		catch (Exception e) {
			askelok = false;
		}
/*Tarkista suunta, mihin lasketaan*/
		if (askelok) askelpituus = htemp;
		double h = askelpituus;
		if ((thuippu - t0) < 0) {
			h = -h;
			suunta = -1;
		}
/*Alusta uusi polygoni*/
		kayra = new Polygon();
/*Lis polygoniin alkupiste*/
		kayra.addPoint(xMuutosruudulle(t0),yMuutosruudulle(y0));
/*Laske kyrlle arvoja, kunnes saavutetaan thuippu tai, kun laskennassa tulee ongelma*/
		while ((suunta*(thuippu-t) > 0) && solv.error == false) {
			sij[0]=y[0]+h*solv.evaluate(t,y)[0];
			y[0] += h/2*(solv.evaluate(t,y)[0]+solv.evaluate(t+h,sij)[0]);
			t += h;
			if (solv.error == false) {
				if (y[0] < 2*yleveys && y[0] > 2*(-yleveys)){
					kayra.addPoint(xMuutosruudulle(t),yMuutosruudulle(y[0]));
				}
				else solv.error = true;
			}
		}
		solv.error = false;
	}
/*Runge-kutta*/
	public final void rungekutta(double t0, double y0, double thuippu) {
		double htemp=0;
		double[] sij = new double[1];
		double[] y = new double[1];
		y[0] = y0;
		double t = t0;
		double k1=0, k2=0, k3=0, k4=0;
		int suunta = 1;
		boolean askelok = true;
		try {
			htemp=new Double(askel.getText()).doubleValue();
		}
		catch (Exception e) {
			askelok = false;
		}
		if (askelok) askelpituus = htemp;
		double h = askelpituus;
		if ((thuippu - t0) < 0) {
			h = -h;
			suunta = -1;
		}
		kayra = new Polygon();
		kayra.addPoint(xMuutosruudulle(t0),yMuutosruudulle(y0));
		while ((suunta*(thuippu-t) > 0) && solv.error == false) {
			k1 = h*solv.evaluate(t,y)[0];
			sij[0]=y[0]+k1/2;
			k2 = h*solv.evaluate(t+h/2,sij)[0];
			sij[0]=y[0]+k2/2;
			k3 = h*solv.evaluate(t+h/2,sij)[0];
			sij[0]=y[0]+k3;
			k4 = h*solv.evaluate(t+h,sij)[0];
			y[0] = y[0] + (k1+2*k2+2*k3+k4)/6;
			t = t + h;
			if (solv.error == false) {
				if (y[0] < 2*yleveys && y[0] > 2*(-yleveys)){
					kayra.addPoint(xMuutosruudulle(t),yMuutosruudulle(y[0]));
				}
				else solv.error = true;
			}
		}
		solv.error = false;
	}
/*Adams-Bashforth*/
	public final void adamsbashforth(double t0, double y0, double thuippu) {
		double htemp=0;
		int lask = 0;
		double[] sij = new double[1];
		double[] sij1 = new double[1];
		double[] sij2 = new double[1];
		double[] sij3 = new double[1];
		double[] y = new double[1];
		y[0] = y0;
		double t = t0;
		double[] arvot = new double[4];
		double k1=0, k2=0, k3=0, k4=0;
		int suunta = 1;
		boolean askelok = true;
		try {
			htemp=new Double(askel.getText()).doubleValue();
		}
		catch (Exception e) {
			askelok = false;
		}
		if (askelok) askelpituus = htemp;
		double h = askelpituus;
		if ((thuippu - t0) < 0) {
			h = -h;
			suunta = -1;
		}
		kayra = new Polygon();
		kayra.addPoint(xMuutosruudulle(t0),yMuutosruudulle(y0));
		for (lask=0; lask < 4; lask++) {
			k1 = h*solv.evaluate(t,y)[0];
			sij[0]=y[0]+k1/2;
			k2 = h*solv.evaluate(t+h/2,sij)[0];
			sij[0]=y[0]+k2/2;
			k3 = h*solv.evaluate(t+h/2,sij)[0];
			sij[0]=y[0]+k3;
			k4 = h*solv.evaluate(t+h,sij)[0];
			y[0] = y[0] + (k1+2*k2+2*k3+k4)/6;
			t = t + h;
			arvot[lask]=y[0];
			if (solv.error == false) {
				if (y[0] < 2*yleveys && y[0] > 2*(-yleveys)){
					kayra.addPoint(xMuutosruudulle(t),yMuutosruudulle(y[0]));
				}
				else solv.error = true;
			}
		}
		while ((suunta*(thuippu-t) > 0) && solv.error == false) {
			sij3[0] = arvot[3];
			sij2[0] = arvot[2];
			sij1[0] = arvot[1];
			sij[0] = arvot[0];
			y[0] = y[0] + h/24*(55*solv.evaluate(t,sij3)[0]-59*solv.evaluate(t-h,sij2)[0]+37*solv.evaluate(t-h*2,sij1)[0]-9*solv.evaluate(t-h*3,sij)[0]);
			t = t + h;
			arvot[0]=arvot[1];
			arvot[1]=arvot[2];
			arvot[2]=arvot[3];
			arvot[3]=y[0];
			if (solv.error == false) {
				if (y[0] < 2*yleveys && y[0] > 2*(-yleveys)){
					kayra.addPoint(xMuutosruudulle(t),yMuutosruudulle(y[0]));
				}
				else solv.error = true;
			}
		}
		solv.error = false;
	}
/*Adaptiivinen Runge-Kutta*/
	public final void adaptive(double t0, double y0, double thuippu) {
	double delta=0, tau;
	double ttemp;
	double tol = 0.001;
	double t = t0;
	double hmin = Math.abs(thuippu - t)/20000;
	double hmax = Math.abs(thuippu - t)/5;
	double h = (thuippu - t)/100;
	double[] sij = new double[1];
	double[] y = new double[1];
	y[0] = y0;
	double s1 = 0;
	double s2 = 0;
	double ytemp;
	double s3 = 0;
	double pow = 1/3;
	int merkki = 1;
	kayra = new Polygon();
	kayra.addPoint(xMuutosruudulle(t0),yMuutosruudulle(y0));
	while ((Math.abs(t - thuippu) > 0) && (Math.abs(h) >= hmin)&& solv.error == false) {
      	if ( (h > 0 & t + h > thuippu) || ((h < 0) && (t + h < thuippu)) )
			h = thuippu - t;
		s1 = solv.evaluate(t, y)[0];
		sij[0]=y[0]+h*s1;
		s2 = solv.evaluate(t+h, sij)[0];
		sij[0]=y[0]+h*(s1+s2)/4;
		s3 = solv.evaluate(t+h/2,sij)[0];
		if (solv.error == false) {
			tau = tol * Math.max(Math.abs(y[0]), 1);
			delta = Math.abs(h*(s1 - 2*s3 + s2)/3);
			if (delta <= tau) {
				t += h;
				ytemp = y[0]+h*(s1+4*s3+s2)/6;
		   		y[0] = ytemp;
				if ((y[0] < ymax+2*yleveys) && (y[0] > ymin-2*yleveys))
					kayra.addPoint(xMuutosruudulle(t),yMuutosruudulle(y[0]));
				h=h*1.1;
			}

			else h=h*0.9;
		}
	}
	solv.error =false;
	}

/*kuvaajat ja tausta*/
	public final class Piirtoalusta extends Canvas {
		Color numvari= new Color(0,0,0);
		Color suuntavari= new Color(204,204,255).darker();	
		Color asteikkovari= new Color(0,0,0);
		double skpituus = 9;
		public void paint(Graphics g){
			double[] suunta = new double[2];
			double[] sij = new double[1];
			int laskin = 0;
			double alku;
			double x;
			double askelx,askely;
			double skxkoord;
			double skykoord;
			double sklaskin;
			double skx0,sky0,skx1,sky1,yksx,yksy,pituus,kx,ky;
			double skxaskel = (tleveys) / 15;
			double skyaskel = (yleveys) / 15;
			int xtemp = 0;
			int ytemp = 0;
			lue2.setText("Wait");
/*Koordinaatisto*/
			if (tleveys <= 10) {
				askelx = 1;
				while (((tleveys)/askelx) < 8)
					askelx /= 2;
			}
			else {
				askelx = 0.5;	
				while (((tleveys)/askelx) > 10)
					askelx += 0.5;
			}
			if (yleveys <= 10) {
				askely = 1;
				while (((yleveys)/askely) < 8)
					askely /= 2;
			}
			else {
				askely = 0.5;
				while (((yleveys)/askely) > 10)
					askely += 0.5;
			}
			g.setColor(asteikkovari);
			g.drawRect(25,25,leveys,leveys);
			if (tmax >= 0) {
				if (tmin > 0) alku = tmin;
				else alku = 0;
				for (x = alku; x <= tmax;x += askelx) {
					xtemp = xMuutosruudulle(x);
					ytemp = yMuutosruudulle(ymin);
					g.setColor(asteikkovari);
					g.drawLine(xtemp, yMuutosruudulle(ymax),xtemp,ytemp);
					g.setColor(numvari);
					g.drawString(""+ x,xtemp-10,ytemp+15);
				}
			}
			if (tmin < 0) {
				if (tmax < 0) alku = tmax;
				else alku = askelx;
				for (x = alku; x <= -tmin; x += askelx) {
					xtemp = xMuutosruudulle(-x);
					ytemp = yMuutosruudulle(ymin);
					g.setColor(asteikkovari);
					g.drawLine(xtemp,yMuutosruudulle(ymax),xtemp,ytemp);
					g.setColor(numvari);
					g.drawString(""+ (-x),xtemp-10,ytemp+15);
				}
			}
			if (ymax >= 0) {
				if (ymin > 0) alku = ymin;
				else alku = 0;
				for (x = alku; x <= ymax;x += askely) {
					xtemp = xMuutosruudulle(tmin);	
					ytemp = yMuutosruudulle(x);
					g.setColor(asteikkovari);
					g.drawLine(xtemp, ytemp,xMuutosruudulle(tmax),ytemp);
					g.setColor(numvari);
					g.drawString(""+ x,xtemp-22,ytemp+5);
				}			
			}
			if (ymin < 0) {
				if (ymax < 0) alku = ymax;
				else alku = askely;
				for (x = alku; x <= -ymin; x += askely) {
					xtemp = xMuutosruudulle(tmin);	
					ytemp = yMuutosruudulle(-x);
					g.setColor(asteikkovari);
					g.drawLine(xtemp, ytemp,xMuutosruudulle(tmax),ytemp);
					g.setColor(numvari);
					g.drawString(""+ (-x),xtemp-22,ytemp+5);
				}
			}
/*Suuntakentt*/
			g.setColor(suuntavari);
	   		for (skxkoord = tmin+skxaskel; skxkoord <= tmax-skxaskel; skxkoord += skxaskel){
				for (skykoord = ymin+skyaskel; skykoord <= ymax-skyaskel; skykoord += skyaskel){
					sij[0]=skykoord;
					suunta[0]=1;
					suunta[1]=solv.evaluate(skxkoord,sij)[0];
					if (solv.error == false)
					{
						skx0 = (double)xMuutosruudulle(skxkoord);
						sky0 = (double)yMuutosruudulle(skykoord);
						skx1 = (double)xMuutosruudulle(skxkoord+suunta[0]);
						sky1 = (double)yMuutosruudulle(skykoord+suunta[1]);
						pituus = (double)skpituus/Math.sqrt(Math.pow(skx1-skx0,2)+Math.pow(sky1-sky0,2));
						yksx = (double)(skx1-skx0)*pituus;
						yksy = (double)(sky1-sky0)*pituus;
						g.drawLine((int)skx0,(int)sky0,(int)(skx0+yksx),(int)(sky0+yksy));
						g.drawLine((int)skx0,(int)sky0,(int)(skx0-yksx),(int)(sky0-yksy));	
					}
					laskin++;
				}
			}
/*Piirretn valmiiksi lasketut kyrt*/
			if (kayrat.size()>0) {
				rotaatio=0;
				boolean varilask=true;
				for (laskin = 0; laskin < kayrat.size(); laskin++) {
					if (varilask) {
						g.setColor(annaVari());
						varilask = false;
					}
					else
						varilask = true;
					kayra = (Polygon)kayrat.elementAt(laskin);
					g.drawOval(kayra.xpoints[0]-5,kayra.ypoints[0]-5,10,10);
					g.drawPolyline(kayra.xpoints,kayra.ypoints,kayra.npoints);
				}
			}
			lue2.setText("Ready");
		}
	}

}

