Notebook[{


Cell[CellGroupData[{

Cell["Roikkuva ketju", "Title"],

Cell[TextData[{
  "Tarkastellaan kitkattoman, taipuisan ketjun potentiaalienergiaa. \
Jos ketju riippuu molemmista p\[ADoubleDot]ist\[ADoubleDot] \
kiinnitettyn\[ADoubleDot], se hakee muodon, joka antaa \
potentiaalienergialle minimiarvon.  Variaatiolaskennan avulla voidaan \
osoittaa, ett\[ADoubleDot] kun ketjun potentiaalienergialla on \
minimi, niin ketjun muoto ",
  Cell[BoxData[
      \(TraditionalForm\`y\  = \ y(x)\)]],
  " noudattaa differentiaaliyht\[ADoubleDot]l\[ODoubleDot]\
\[ADoubleDot]"
}], "Text"],

Cell[BoxData[
    \(\(\(d\^2\) y\)\/\(d\ x\^2\) = 
      k \@\( 1 + \(\(\((\(d\ y\)\/\(d\ x\))\)\^2\)\(.\)\)\)\)], \
"DisplayFormula"],

Cell[TextData[{
  "T\[ADoubleDot]ss\[ADoubleDot] ",
  Cell[BoxData[
      \(k\)], "DisplayFormula"],
  " on ketjun pituuden ep\[ADoubleDot]suorasti m\[ADoubleDot]\
\[ADoubleDot]r\[ADoubleDot]\[ADoubleDot]v\[ADoubleDot] tekij\
\[ADoubleDot]. Tarkastellaan roikkuvan ketjun muotoa eri \
reunaehdoilla. Poistetaan ensin vanhat muuttujat."
}], "Text"],

Cell[BoxData[
    \(Remove["\<Global`*\>"]\)], "Input"],

Cell[TextData[{
  "Muodostetaan ketjua kuvaava toisen kertaluvun differentiaaliyht\
\[ADoubleDot]l\[ODoubleDot].  Valitaan ",
  Cell[BoxData[
      \(k = 1\)], "DisplayFormula"],
  ". "
}], "Text"],

Cell[BoxData[
    \(k = 1; 
    yht = \ \(y''\)[x] == k\ Sqrt[1 + \(y'\)[x]^2]\)], "Input"],

Cell[TextData[{
  "Valitaan reunaehdot symmetrisesti origon molemmin puolin. Ketju \
olkoon kiinnitetty pisteiss\[ADoubleDot] ",
  Cell[BoxData[
      \(TraditionalForm\`x\  = \ 1\)]],
  " ja ",
  Cell[BoxData[
      \(TraditionalForm\`x\  = \ \(-1\)\)]],
  "."
}], "Text"],

Cell[BoxData[
    \(reunaehto1 = {y[\(-1\)] == 0, y[1] == 0}\)], "Input"],

Cell["Ratkaistaan yht\[ADoubleDot]l\[ODoubleDot]:", "Text"],

Cell[BoxData[
    \(rtk1 = \ 
      DSolve[Flatten[{yht, reunaehto1}], y[x], x]\)], "Input"],

Cell[TextData[{
  "Ratkaisualgoritmissa k\[ADoubleDot]ytet\[ADoubleDot]\[ADoubleDot]n \
monihaaraisia k\[ADoubleDot]\[ADoubleDot]nteisfunktioita, mist\
\[ADoubleDot]",
  StyleBox["  ",
    FontSlant->"Italic"],
  StyleBox["DSolve",
    FontFamily->"Courier New"],
  " antaa varoituksen. Ketjun muoto noudattaa hyperbolista kosinia, \
jonka kuvaajaa t\[ADoubleDot]st\[ADoubleDot] syyst\[ADoubleDot] \
kutsutaankin ",
  StyleBox["ketjuk\[ADoubleDot]yr\[ADoubleDot]ksi",
    FontSlant->"Italic"],
  ". Sievennet\[ADoubleDot]\[ADoubleDot]n tulosta."
}], "Text"],

Cell[BoxData[
    \(kaari1 = y[x] /. rtk1 // FullSimplify\)], "Input"],

Cell[TextData[{
  "Valitaan ratkaisuista se, joka aukeaa yl\[ODoubleDot]sp\
\[ADoubleDot]in",
  StyleBox[" ",
    FontSlant->"Italic"],
  StyleBox["(",
    FontFamily->"Courier New"],
  Cell[BoxData[
      \(TraditionalForm\`cosh(x)\)]],
  StyleBox[")",
    FontFamily->"Courier New"],
  StyleBox[" ja",
    FontVariations->{"CompatibilityType"->0}],
  " piirret\[ADoubleDot]\[ADoubleDot]n kuvaaja ketjun \
riippumisasennolle."
}], "Text"],

Cell[BoxData[
    \(Plot[kaari1[\([2]\)], {x, \(-1\), 1}, 
      AspectRatio -> Automatic]\)], "Input"],

Cell["\<\
Ent\[ADoubleDot] kun ketjun toinen p\[ADoubleDot]\[ADoubleDot] on \
merkitt\[ADoubleDot]v\[ADoubleDot]sti korkeammalla? Muutetaan \
reunaehtoja ja ratkaistaan yht\[ADoubleDot]l\[ODoubleDot]t.\
\>", "Text"],

Cell[BoxData[
    \(reunaehto2 = {y[\(-1\)] == 0, y[1] == 3}\)], "Input"],

Cell[BoxData[
    \(rtk2 = \ 
      DSolve[Flatten[{yht, reunaehto2}], y[x], x] // N\)], "Input"],

Cell["\<\
J\[ADoubleDot]lleen ep\[ADoubleDot]varmuutta aiheuttava \
k\[ADoubleDot]\[ADoubleDot]nteisfunktio. Sievennet\[ADoubleDot]\
\[ADoubleDot]n tulosta:\
\>", "Text"],

Cell[BoxData[
    \(kaari2 = y[x] /. rtk2 // Simplify\)], "Input"],

Cell["\<\
Tulokseksi saadaan hieman monimutkaisempi riippumisk\[ADoubleDot]yr\
\[ADoubleDot]. Valitaan yl\[ODoubleDot]sp\[ADoubleDot]in aukeava \
ratkaisu ja piirret\[ADoubleDot]\[ADoubleDot]n sen kuvaaja. \
(Mathematican eri versiot saattavat antaa ratkaisut eri \
j\[ADoubleDot]rjestyksess\[ADoubleDot], joten on tutkittava, kumpi \
ratkaisu aukeaa oikeaan suuntaan.)\
\>", "Text"],

Cell[BoxData[
    \(Plot[kaari2[\([1]\)], {x, \(-1\), 1}, 
      AspectRatio -> Automatic]\)], "Input"],

Cell[TextData[{
  "Kun k\[ADoubleDot]yr\[ADoubleDot]n yht\[ADoubleDot]l\[ODoubleDot] \
ilmaistaan muodossa",
  StyleBox[" ",
    FontSlant->"Italic"],
  StyleBox["y = f(x)",
    FontFamily->"Courier New",
    FontSlant->"Italic"],
  ", saadaan k\[ADoubleDot]yr\[ADoubleDot]n pituus ",
  StyleBox["L",
    FontFamily->"Courier New",
    FontSlant->"Italic"],
  " laskemalla"
}], "Text"],

Cell[BoxData[
    \(\(\(L = \[Integral]\_\(x\_1\)\%\(x\_2\)\(\@\(1 + 
                y'\^2\)\) \[DifferentialD]x\)\(,\)\)\)], \
"DisplayFormula"],

Cell[TextData[{
  "miss\[ADoubleDot] ",
  Cell[BoxData[
      \(y' = \(d\ y\)\/\(d\ x\)\)], "DisplayFormula"],
  ". T\[ADoubleDot]t\[ADoubleDot] yht\[ADoubleDot]l\[ODoubleDot]\
\[ADoubleDot] voidaan soveltaa my\[ODoubleDot]s ratkaistuihin \
riippuvien ketjujen yht\[ADoubleDot]l\[ODoubleDot]ihin. Lasketaan \
ensimm\[ADoubleDot]isen\[ADoubleDot] lasketun k\[ADoubleDot]yr\
\[ADoubleDot]n pituus. M\[ADoubleDot]\[ADoubleDot]ritell\[ADoubleDot]\
\[ADoubleDot]n ensin integraalin sis\[ADoubleDot]ll\[ADoubleDot] \
oleva funktio:"
}], "Text"],

Cell[BoxData[
    \(ketju = \ kaari1[\([1]\)]; \ 
    fkt[x_] = Sqrt[1 + D[ketju, x]^2]\)], "Input"],

Cell["Sitten integroidaan:", "Text"],

Cell[BoxData[
    \(pit = NIntegrate[fkt[x], {x, \(-1\), 1}]\)], "Input"],

Cell[CellGroupData[{

Cell["Teht\[ADoubleDot]vi\[ADoubleDot]", "Subtitle"],

Cell[TextData[{
  StyleBox["Portaikko suljetaan ketjulla, joka ripustetaan kahden \
tolpan v\[ADoubleDot]lille. Tolppien et\[ADoubleDot]isyys on 1 m ja \
korkeus 70 cm. \nRatkaise graafisesti kokeilemalla (",
    Background->None],
  StyleBox["k",
    FontFamily->"Courier New",
    FontSlant->"Italic",
    Background->None],
  StyleBox[":n arvoa muuttamalla ), mink\[ADoubleDot] pituinen ketju \
tarvitaan, kun ketjun alimmaiskorkeuden tulee olla 50 cm. Kun muutat \
",
    Background->None],
  StyleBox["k",
    FontFamily->"Courier New",
    FontSlant->"Italic",
    Background->None],
  StyleBox[":n arvoa, saatat kohdata \
yll\[ADoubleDot]tt\[ADoubleDot]vi\[ADoubleDot] vaikeuksia \
differentiaaliyht\[ADoubleDot]l\[ODoubleDot]n ratkaisussa. Johtuen ",
    Background->None],
  StyleBox["Mathematica",
    Background->None,
    FontVariations->{"CompatibilityType"->0}],
  StyleBox["n k\[ADoubleDot]ytt\[ADoubleDot]m\[ADoubleDot]st\
\[ADoubleDot] ratkaisurutiinista ja funktioiden haaroista \
kompleksitasossa, ratkaisuyht\[ADoubleDot]l\[ODoubleDot]t sis\
\[ADoubleDot]lt\[ADoubleDot]v\[ADoubleDot]t useita p\[ADoubleDot]\
\[ADoubleDot]llekk\[ADoubleDot]isi\[ADoubleDot] juuria. \
Laskentaresursseista riippuen on syyt\[ADoubleDot] tyyty\[ADoubleDot] \
",
    Background->None],
  StyleBox["k",
    FontFamily->"Courier New",
    FontSlant->"Italic",
    Background->None],
  StyleBox[":n 1 \[Dash] 2 desimaalin tarkkuuteen, sill\[ADoubleDot] \
se antaa ketjun pituudelle jo alle senttimetrin tarkkuuden. Ketjun \
pituudeksi tulee n. 109.7 cm. ",
    Background->None]
}], "Text",
  Background->RGBColor[1, 1, 0]],

Cell[TextData[{
  StyleBox["Mathematica",
    Background->None,
    FontVariations->{"CompatibilityType"->0}],
  StyleBox[" ei osaa ratkaista riippuvan ketjun yht\[ADoubleDot]l\
\[ODoubleDot]\[ADoubleDot], mik\[ADoubleDot]li ",
    Background->None],
  StyleBox["k",
    FontFamily->"Courier New",
    FontSlant->"Italic",
    Background->None],
  StyleBox[":lle ei ole m\[ADoubleDot]\[ADoubleDot]ritelty lukuarvoa. \
L\[ODoubleDot]yd\[ADoubleDot]tk\[ODoubleDot] yhteyden ketjun pituuden \
ja vakion ",
    Background->None],
  StyleBox["k",
    FontFamily->"Courier New",
    FontSlant->"Italic",
    Background->None],
  StyleBox[" v\[ADoubleDot]lille kokeilemalla ",
    Background->None],
  StyleBox["k",
    FontFamily->"Courier New",
    FontSlant->"Italic",
    Background->None],
  StyleBox[":lle eri arvoja? ",
    Background->None]
}], "Text",
  Background->RGBColor[1, 1, 0]],

Cell[TextData[{
  "Roikkuvan ketjun potentiaalienergiaa kuvaa integraali ",
  Cell[BoxData[
      \(TraditionalForm\`\[Integral]\_\(x\_1\)\%\(x\_2\)\(y(
            x)\)\ \(\@\(1 + \ 
                y' \((x)\)\^2\)\) \[DifferentialD]x\)]],
  ", kun ketjun massatiheys pituusyksikk\[ODoubleDot]\[ADoubleDot] \
kohden on asetettu ",
  Cell[BoxData[
      \(TraditionalForm\`\(\(=\)\(\ \)\(1\)\)\)]],
  ". Variaatiolaskennan Eulerin yht\[ADoubleDot]l\[ODoubleDot]n \
mukaan t\[ADoubleDot]m\[ADoubleDot] saa minimiarvonsa, kun ",
  Cell[BoxData[
      \(TraditionalForm\`y\ y''\  = \ 1\  + \ y'\^2\)]],
  ". Etsi t\[ADoubleDot]m\[ADoubleDot]n \
yht\[ADoubleDot]l\[ODoubleDot]n yleinen ratkaisu alkeisfunktioiden \
avulla. Johda edell\[ADoubleDot] \
l\[ADoubleDot]ht\[ODoubleDot]kohdaksi otettu differentiaaliyht\
\[ADoubleDot]l\[ODoubleDot] ratkaisun v\[ADoubleDot]litulosten \
avulla. Vihje: Kyseess\[ADoubleDot] on toisen kertaluvun yht\
\[ADoubleDot]l\[ODoubleDot], jossa muuttuja ",
  Cell[BoxData[
      \(TraditionalForm\`x\)]],
  " ei esiinny eksplisiittisesti. ",
  StyleBox["Mathematica",
    FontVariations->{"CompatibilityType"->0}],
  "a voi k\[ADoubleDot]ytt\[ADoubleDot]\[ADoubleDot] laskuissa hy\
\[ODoubleDot]dyksi, vaikka se ei osannekaan ratkaista \
differentiaaliyht\[ADoubleDot]l\[ODoubleDot]\[ADoubleDot] suoraan."
}], "Text",
  Background->RGBColor[1, 1, 0]]
}, Open  ]]
}, Open  ]],

Cell["JP & SKK 09.05.2001", "Text",
  FontSlant->"Italic"]

},
FrontEndVersion->"4.1 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
CellGrouping->Manual,
WindowSize->{683, 641},
WindowMargins->{{0, Automatic}, {Automatic, -5}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
CellLabelAutoDelete->True
]
