Notebook[{


Cell[CellGroupData[{

Cell["Airyn differentiaaliyht\[ADoubleDot]l\[ODoubleDot]", "Title"],

Cell["\<\
Airyn differentiaaliyht\[ADoubleDot]l\[ODoubleDot] on hyvin \
yksinkertainen toisen kertaluvun lineaarinen ja homogeeninen \
differentiaaliyht\[ADoubleDot]l\[ODoubleDot], joka kuitenkaan ei ole \
ratkaistavissa tavallisten alkeisfunktioiden avulla:\
\>", "Text"],

Cell[BoxData[
    \(airyyht = \ \(y''\)[x]\  - \ x\ y[x]\  == \ 0\)], "Input"],

Cell[BoxData[
    \(ylrtk = \ DSolve[airyyht, y, x]\)], "Input"],

Cell["\<\
Mathematica tuntee kuitenkin laajemman kokoelman funktioita, ja n\
\[ADoubleDot]iden avulla voidaan lausua sek\[ADoubleDot] \
differentiaaliyht\[ADoubleDot]l\[ODoubleDot]n yleinen ratkaisu ett\
\[ADoubleDot] sen derivaatta:\
\>", "Text"],

Cell[BoxData[
    \(airy = \ y /. First[ylrtk]\)], "Input"],

Cell[BoxData[
    \(airy[x]\)], "Input"],

Cell[BoxData[
    \(airyder = \ airy'\)], "Input"],

Cell[BoxData[
    \(airyder[x]\)], "Input"],

Cell["\<\
Kaksi lineaarisesti riippumatonta yksitt\[ADoubleDot]isratkaisua \
saadaan antamalla sopivat alkuehdot ja ratkaisemalla \
n\[ADoubleDot]ist\[ADoubleDot] vakiot: \
\>", "Text"],

Cell[BoxData[
    \(vakiot1 = \ 
      Solve[{airy[0] == 1, airyder[0] == 0}, {C[1], 
          C[2]}]\)], "Input"],

Cell[BoxData[
    \(vakiot2 = \ 
      Solve[{airy[0] == 0, airyder[0] == 1}, {C[1], 
          C[2]}]\)], "Input"],

Cell["\<\
Saadut lausekkeet sis\[ADoubleDot]lt\[ADoubleDot]v\[ADoubleDot]t \
uuden erikoisfunktion, gammafunktion. T\[ADoubleDot]lle \
k\[ADoubleDot]ytet\[ADoubleDot]\[ADoubleDot]n yleens\[ADoubleDot] \
symbolia \[CapitalGamma] (kreikkalainen kirjain iso gamma).\
\>", "Text"],

Cell["Vakioita vastaavat yksitt\[ADoubleDot]isratkaisut ovat", \
"Text"],

Cell[BoxData[
    \(rtk1 = \ airy[x] /. First[vakiot1]\)], "Input"],

Cell[BoxData[
    \(rtk2 = \ airy[x] /. First[vakiot2]\)], "Input"],

Cell[TextData[{
  "N\[ADoubleDot]m\[ADoubleDot] voidaan \[LongDash] hieman \
Mathematican versiosta riippuen \[LongDash] saada my\[ODoubleDot]s \
suoraan ",
  StyleBox["DSolve",
    FontFamily->"Courier New"],
  "-komennolla:"
}], "Text"],

Cell[BoxData[
    \(DSolve[{airyyht, y[0] \[Equal] 1, \(y'\)[0] \[Equal] 0}, y[x], 
      x]\)], "Input"],

Cell[BoxData[
    \(DSolve[{airyyht, y[0] \[Equal] 0, \(y'\)[0] \[Equal] 1}, y[x], 
      x]\)], "Input"],

Cell["\<\
N\[ADoubleDot]iden kuvaajista on n\[ADoubleDot]ht\[ADoubleDot]viss\
\[ADoubleDot] er\[ADoubleDot]it\[ADoubleDot] toisen kertaluvun \
homogeeniyht\[ADoubleDot]l\[ODoubleDot]lle luonteenomaisia piirteit\
\[ADoubleDot]:\
\>", "Text"],

Cell[BoxData[
    \(Plot[{rtk1, rtk2}, {x, \(-15\), 2}]\)], "Input"],

Cell[TextData[{
  "Jos differentiaaliyht\[ADoubleDot]l\[ODoubleDot]ss\[ADoubleDot] ",
  Cell[BoxData[
      \(TraditionalForm\`y''\  + \ \ k\ y\  = 0\)]],
  " vakio ",
  Cell[BoxData[
      \(TraditionalForm\`k\)]],
  " on positiivinen, kyseess\[ADoubleDot] on vakiokertoiminen yht\
\[ADoubleDot]l\[ODoubleDot], jonka ratkaisuna on ",
  Cell[BoxData[
      \(TraditionalForm\`y\  = \ 
        C\_1\ sin\ \(\@k\) x\  + \ C\_2\ cos \(\@ k\) x\)]],
  ", ts. sini-kosini-v\[ADoubleDot]r\[ADoubleDot]htely. \
V\[ADoubleDot]r\[ADoubleDot]htelyn taajuus on sit\[ADoubleDot] \
suurempi, mit\[ADoubleDot] suurempi ",
  Cell[BoxData[
      \(TraditionalForm\`k\)]],
  " on. Negatiivisilla muuttujan ",
  Cell[BoxData[
      \(TraditionalForm\`x\)]],
  " arvoilla Airyn yht\[ADoubleDot]l\[ODoubleDot] on t\[ADoubleDot]m\
\[ADoubleDot]ntyyppinen: Yht\[ADoubleDot]l\[ODoubleDot] voidaan \
kirjoittaa muotoon ",
  Cell[BoxData[
      \(TraditionalForm\`\(\(y''\)\(\ \)\(+\)\)\  | x | \ y\  = \ 
        0\)]],
  ", ja sen ratkaisuna n\[ADoubleDot]ytt\[ADoubleDot]\[ADoubleDot] \
olevan v\[ADoubleDot]r\[ADoubleDot]htely, jonka taajuus kasvaa, kun \
",
  Cell[BoxData[
      \(TraditionalForm\`\(\(|\)\(x\)\(|\)\)\)]],
  " kasvaa."
}], "Text"],

Cell[TextData[{
  "Vastaavalla tavalla Airyn yht\[ADoubleDot]l\[ODoubleDot] voidaan \
rinnastaa positiivisilla muuttujan arvoilla yht\[ADoubleDot]l\
\[ODoubleDot]\[ODoubleDot]n ",
  Cell[BoxData[
      \(TraditionalForm\`y''\  - \ k\ y\  = \ 0\)]],
  ", miss\[ADoubleDot] ",
  Cell[BoxData[
      \(TraditionalForm\`k\)]],
  " on positiivinen. T\[ADoubleDot]m\[ADoubleDot]n ratkaisut \
muodostuvat eksponenttifunktioista: ",
  Cell[BoxData[
      \(TraditionalForm\`y\  = \ \(C\_\(\(1\)\(\ \)\)\) \
\[ExponentialE]\^\(\(\@k\) x\)\  + \ 
          C\_2\ \[ExponentialE]\^\(\(-\@\(\(k\)\(\ \)\)\) x\)\)]],
  "."
}], "Text"],

Cell["\<\
Kuvaajat n\[ADoubleDot]ytt\[ADoubleDot]v\[ADoubleDot]t \
my\[ODoubleDot]s toisen kertaluvun homogeeniyht\[ADoubleDot]l\
\[ODoubleDot]iden ratkaisuille tyypillisen ominaisuuden: Jos kahdella \
lineaarisesti riippumattomalla ratkaisulla on nollakohtia, n\
\[ADoubleDot]m\[ADoubleDot] vuorottelevat. Toisen ratkaisun kahden \
per\[ADoubleDot]kk\[ADoubleDot]isen nollakohdan v\[ADoubleDot]liss\
\[ADoubleDot] on t\[ADoubleDot]sm\[ADoubleDot]lleen yksi toisen \
ratkaisun nollakohta. Todistus perustuu Wronskin determinantin \
ominaisuuksiin.\
\>", "Text"]
}, Open  ]],

Cell["SKK 27.04.2001", "Text",
  FontSlant->"Italic"]

},
FrontEndVersion->"4.1 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
CellGrouping->Manual,
WindowSize->{634, 537},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic}
]
