Notebook[{

Cell[CellGroupData[{
Cell["Differentiaaliyht\[ADoubleDot]l\[ODoubleDot]t", "Section"],

Cell["Sovellukset", "Subsection"],

Cell["Geometria", "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell["K\[ADoubleDot]yr\[ADoubleDot]parven kohtisuorat leikkaajat", \
"Title"],

Cell[TextData[{
  "K\[ADoubleDot]yr\[ADoubleDot]parven ",
  StyleBox["kohtisuoriksi leikkaajiksi",
    FontSlant->"Italic"],
  " kutsutaan toista k\[ADoubleDot]yr\[ADoubleDot]parvea, jonka k\
\[ADoubleDot]yr\[ADoubleDot]t leikkaavat ensinmainitun parven k\
\[ADoubleDot]yr\[ADoubleDot]t kohtisuorasti jokaisessa \
leikkauspisteess\[ADoubleDot]. Kahden k\[ADoubleDot]yr\[ADoubleDot]n \
kohtisuora leikkaaminen tarkoittaa leikkauspisteeseen asetettujen \
tangenttien kohtisuoruutta."
}], "Text"],

Cell["\<\
Ongelma on luonteeltaan geometrinen, mutta sill\[ADoubleDot] on \
merkitys my\[ODoubleDot]s sovelluksissa: esimerkiksi s\[ADoubleDot]hk\
\[ODoubleDot]kent\[ADoubleDot]n kentt\[ADoubleDot]viivat ja \
tasapotentiaalipinnat (tai tasokuvassa \
tasapotentiaalik\[ADoubleDot]yr\[ADoubleDot]t) ovat toisiaan vastaan \
kohtisuorat.\
\>", "Text"],

Cell["Poistetaan mahdolliset aikaisemmat muuttujat:", "Text"],

Cell[BoxData[
    \(Remove["\<Global`*\>"]\)], "Input"],

Cell["\<\
Yksinkertainen esimerkki k\[ADoubleDot]yr\[ADoubleDot]parven \
kohtisuorista leikkaajista on origokeskinen ympyr\[ADoubleDot]parvi, \
jonka kohtisuorat leikkaajat ovat origon kautta kulkevat suorat, \
kuten seuraava kuvio osoittaa:\
\>", "Text"],

Cell[BoxData[{
    \(\(ympyraparvi = \ 
        ParametricPlot[
          Evaluate[
            Table[{r\ Cos[2\ n\ Pi/20], r\ Sin[2\ n\ Pi/20]}, {r, 1, 
                7}]], {n, 0, 20}, 
          DisplayFunction -> \ 
            Identity];\)\), "\[IndentingNewLine]", 
    \(\(suoraparvi = \ 
        Graphics[
          Table[Line[{{0, 0}, {7.5\ Cos[2\ n\ Pi/20], 
                  7.5\ \ Sin[2\ n\ Pi/20]}}], {n, 0, 
              20}]];\)\), "\[IndentingNewLine]", 
    \(Show[ympyraparvi, suoraparvi, 
      PlotRange -> {{\(-8\), 8}, {\(-8\), 8}}, AspectRatio -> 1, 
      DisplayFunction -> $DisplayFunction]\)}], "Input"],

Cell[TextData[{
  "Annetun k\[ADoubleDot]yr\[ADoubleDot]parven kohtisuorat leikkaajat \
voidaan l\[ODoubleDot]yt\[ADoubleDot]\[ADoubleDot] differentiaaliyht\
\[ADoubleDot]l\[ODoubleDot]iden avulla. \
T\[ADoubleDot]ll\[ODoubleDot]in muodostetaan ensin annetulle parvelle \
sen differentiaaliyht\[ADoubleDot]l\[ODoubleDot]. T\[ADoubleDot]m\
\[ADoubleDot] on periaatteessa muotoa ",
  Cell[BoxData[
      \(TraditionalForm\`y'\  = \ f(x, y)\)]],
  " ja antaa siis pisteen ",
  Cell[BoxData[
      \(TraditionalForm\`\((x, y)\)\)]],
  " kautta kulkevan k\[ADoubleDot]yr\[ADoubleDot]n tangentin \
kulmakertoimen t\[ADoubleDot]ss\[ADoubleDot] pisteess\[ADoubleDot]. \
Saman pisteen kautta kulkevan kohtisuoran leikkaajan kulmakerroin on \
t\[ADoubleDot]ll\[ODoubleDot]in ",
  Cell[BoxData[
      \(TraditionalForm\`y'\  = \ \(-1\)/\(f(x, y)\)\)]],
  ". T\[ADoubleDot]m\[ADoubleDot] on kohtisuorien leikkaajien \
differentiaaliyht\[ADoubleDot]l\[ODoubleDot]. Se voidaan kirjoittaa \
my\[ODoubleDot]s muotoon ",
  Cell[BoxData[
      \(TraditionalForm\`\(-1\)/y'\  = \ f(x, y)\)]],
  ", mist\[ADoubleDot] n\[ADoubleDot]kyy, ett\[ADoubleDot] alkuper\
\[ADoubleDot]isen parven \
differentiaaliyht\[ADoubleDot]l\[ODoubleDot]st\[ADoubleDot] p\
\[ADoubleDot]\[ADoubleDot]st\[ADoubleDot]\[ADoubleDot]n kohtisuorien \
leikkaajien yht\[ADoubleDot]l\[ODoubleDot]\[ODoubleDot]n tekem\
\[ADoubleDot]ll\[ADoubleDot] korvaus"
}], "Text"],

Cell[BoxData[
    FormBox[
      RowBox[{
        SuperscriptBox["y", "\[Prime]",
          MultilineFunction->None], " ", "\[RightTeeArrow]", " ", 
        RowBox[{"-", 
          RowBox[{
            FractionBox["1", 
              SuperscriptBox["y", "\[Prime]",
                MultilineFunction->None]], "."}]}]}], 
      TraditionalForm]], "Text",
  TextAlignment->Center],

Cell[TextData[{
  "Korvausta teht\[ADoubleDot]ess\[ADoubleDot] ei yht\[ADoubleDot]l\
\[ODoubleDot]n tarvitse olla normaalimuodossa ",
  Cell[BoxData[
      \(TraditionalForm\`y'\  = \ f(x, y)\)]],
  "."
}], "Text"],

Cell["\<\
Lopuksi ratkaistaan saatu kohtisuorien leikkaajien differentiaaliyht\
\[ADoubleDot]l\[ODoubleDot]. Yleisess\[ADoubleDot] ratkaisussa \
esiintyv\[ADoubleDot] m\[ADoubleDot]\[ADoubleDot]r\[ADoubleDot]\
\[ADoubleDot]m\[ADoubleDot]t\[ODoubleDot]n vakio, integroimisvakio, \
on parven parametri. Kutakin t\[ADoubleDot]m\[ADoubleDot]n \
(sallittua) arvoa vastaa jokin parven \
k\[ADoubleDot]yr\[ADoubleDot].\
\>", "Text"],

Cell["Seuraava esimerkki valaissee menettely\[ADoubleDot].", "Text"],

Cell[TextData[{
  "Olkoon annettuna k\[ADoubleDot]yr\[ADoubleDot]parvi, miss\
\[ADoubleDot] parven parametriksi on merkitty ",
  Cell[BoxData[
      \(TraditionalForm\`C\)]],
  ":"
}], "Text"],

Cell[BoxData[
    \(yhtalo = \ y\  == \ C\ x\ Exp[x^2 + y^2]\)], "Input"],

Cell[TextData[{
  "Koska yht\[ADoubleDot]l\[ODoubleDot]\[ADoubleDot] ei voida \
ratkaista muuttujan ",
  Cell[BoxData[
      \(TraditionalForm\`y\)]],
  " suhteen, on kuva parvesta piirrett\[ADoubleDot]v\[ADoubleDot] \
kirjoittamalla yht\[ADoubleDot]l\[ODoubleDot] muotoon"
}], "Text"],

Cell[BoxData[
    \(TraditionalForm\`C = 
      y\/\(x\ \[ExponentialE]\^\(x\^2 + y\^2\)\)\)], "Input",
  Evaluatable->False],

Cell[TextData[{
  "ja piirt\[ADoubleDot]m\[ADoubleDot]ll\[ADoubleDot] oikeana puolena \
olevan kahden muuttujan funktion \
korkeusk\[ADoubleDot]yri\[ADoubleDot]. T\[ADoubleDot]m\[ADoubleDot] \
voidaan tehd\[ADoubleDot] Mathematican funktiolla ",
  StyleBox["ContourPlot",
    FontFamily->"Courier New",
    FontVariations->{"CompatibilityType"->0}],
  ":"
}], "Text"],

Cell[BoxData[{
    \(\(carvot = \ {\(-0.64\), \(-0.32\), \(-0.16\), \(-0.08\), \
\(-0.04\), \(-0.02\), \(-0.01\), 0, 0.01, 0.02, 0.04, 0.08, 0.16, 
          0.32, 0.64};\)\), "\[IndentingNewLine]", 
    \(kuva1 = \ 
      ContourPlot[
        y/\((x\ Exp[x^2 + y^2])\), {x, \(-2\), 2}, {y, \(-2\), 2}, 
        Contours -> carvot, ContourShading -> False, 
        PlotPoints -> 100]\)}], "Input"],

Cell[TextData[{
  "Parven differentiaaliyht\[ADoubleDot]l\[ODoubleDot]n johtamiseksi \
ajatellaan, ett\[ADoubleDot] muuttuja ",
  Cell[BoxData[
      \(TraditionalForm\`y\)]],
  " on ",
  Cell[BoxData[
      \(TraditionalForm\`x\)]],
  ":n funktio:"
}], "Text"],

Cell[BoxData[
    \(parvi = \ yhtalo /. y -> y[x]\)], "Input"],

Cell[TextData[{
  "Differentiaaliyht\[ADoubleDot]l\[ODoubleDot] saadaan derivoimalla \
parven yht\[ADoubleDot]l\[ODoubleDot] ja eliminoimalla alkuper\
\[ADoubleDot]isest\[ADoubleDot] ja derivoidusta yht\[ADoubleDot]l\
\[ODoubleDot]st\[ADoubleDot] parviparametri ",
  Cell[BoxData[
      \(TraditionalForm\`c\)]],
  ":"
}], "Text"],

Cell[BoxData[
    \(derivparvi = \ D[parvi, x]\)], "Input"],

Cell[BoxData[
    \(diffyht = \ Eliminate[{parvi, derivparvi}, C]\)], "Input"],

Cell["\<\
T\[ADoubleDot]st\[ADoubleDot] saadaan kohtisuorien leikkaajien \
differentiaaliyht\[ADoubleDot]l\[ODoubleDot] tekem\[ADoubleDot]ll\
\[ADoubleDot] edell\[ADoubleDot] esitetty korvaus:\
\>", "Text"],

Cell[BoxData[
    \(diffyht2 = \ 
      diffyht /. \(y'\)[x] -> \(-1\)/\(y'\)[x]\)], "Input"],

Cell["\<\
Differentiaaliyht\[ADoubleDot]l\[ODoubleDot] ratkaistaan ja saadun \
ratkaisun avulla muodostetaan kohtisuorien leikkaajien yht\
\[ADoubleDot]l\[ODoubleDot]:\
\>", "Text"],

Cell[BoxData[
    \(ratk = DSolve[diffyht2, y[x], x]\)], "Input"],

Cell[BoxData[
    \(parvi2 = \ 
      y[x]^2\  == \ \((y[x]^2 /. Last[ratk] // 
            Simplify)\)\)], "Input"],

Cell[BoxData[
    \(yhtalo2 = \ 
      parvi2 /. {y[x] -> y, Exp[4\ C[1]] -> C}\)], "Input"],

Cell[TextData[{
  "Parviparametrina on integroimisvakio ",
  StyleBox["C[1]",
    FontFamily->"Courier New"],
  ", jota on merkitty lyhyemmin ",
  Cell[BoxData[
      \(TraditionalForm\`C\)]],
  " samalla lauseketta hieman sievent\[ADoubleDot]en."
}], "Text"],

Cell["\<\
Kohtisuorien leikkaajien parvi voidaan \
piirt\[ADoubleDot]\[ADoubleDot] samalla menettelyll\[ADoubleDot] kuin \
alkuper\[ADoubleDot]inen parvi:\
\>", "Text"],

Cell[BoxData[
    \(lauseke2 = C /. First[Solve[yhtalo2, C]]\)], "Input"],

Cell[BoxData[
    \(carvot = \ {\(-0.8\), \(-0.7\), \(-0.6\), \(-0.5\), \(-0.4\), \
\(-0.3\), \(-0.2\), \(-0.1\), 0, 0.1, 0.2, 0.4, 0.7, 1.1, 1.6, 2.2, 
        2.9, 3.7}; 
    kuva2 = \ 
      ContourPlot[lauseke2, {x, \(-2\), 2}, {y, \(-2\), 2}, 
        Contours -> carvot, ContourShading -> False, 
        PlotPoints -> 100]\)], "Input"],

Cell["Molemmat parvet samassa kuvassa:", "Text"],

Cell[BoxData[
    \(Show[kuva1, kuva2]\)], "Input"],

Cell[CellGroupData[{

Cell["Teht\[ADoubleDot]v\[ADoubleDot]", "Subtitle"],

Cell[TextData[{
  "Muodosta hyperbeliparven ",
  Cell[BoxData[
      \(TraditionalForm\`x\^2\  - \ 2\ y\^2\  = \ C\)]],
  " kohtisuorat leikkaajat."
}], "Text",
  Background->RGBColor[1, 1, 0]]
}, Open  ]]
}, Open  ]],

Cell["SKK 10.05.2001", "Text",
  FontSlant->"Italic"]


Cell["\<\
sovell/orttrpol: k\[ADoubleDot]yr\[ADoubleDot]parven kohtisuorat \
leikkaajat napakoordinaateissa\
\>", "Text"]
},
FrontEndVersion->"4.1 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
CellGrouping->Manual,
WindowSize->{623, 646},
WindowMargins->{{14, Automatic}, {Automatic, 1}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
CellLabelAutoDelete->True
]
