Notebook[{

Cell[CellGroupData[{
Cell["Differentiaaliyht\[ADoubleDot]l\[ODoubleDot]t", "Section"],

Cell["Esimerkit", "Subsection"],

Cell["Numeerinen ratkaiseminen", "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Differentiaaliyht\[ADoubleDot]l\[ODoubleDot]ryhm\[ADoubleDot]", \
"Title"],

Cell[TextData[{
  "Ensimm\[ADoubleDot]isen kertaluvun differentiaaliyht\[ADoubleDot]l\
\[ODoubleDot]ryhm\[ADoubleDot] \[LongDash] vaikkapa korkeamman \
kertaluvun yht\[ADoubleDot]l\[ODoubleDot]\[ADoubleDot] vastaava \
normaaliryhm\[ADoubleDot] \[LongDash] voidaan ratkaista numeerisesti \
t\[ADoubleDot]sm\[ADoubleDot]lleen samanlaisilla kaavoilla kuin \
ensimm\[ADoubleDot]isen kertaluvun yht\[ADoubleDot]l\[ODoubleDot] ",
  Cell[BoxData[
      \(TraditionalForm\`y'\  = \ f(x, y)\)]],
  ". Edellytyksen\[ADoubleDot] luonnollisesti on, ett\[ADoubleDot] \
alkuehto on annettu."
}], "Text"],

Cell["\<\
Seuraavat koodit ovat t\[ADoubleDot]sm\[ADoubleDot]lleen samat kuin \
ensimm\[ADoubleDot]isen kertaluvun yht\[ADoubleDot]l\[ODoubleDot]\
\[ADoubleDot] koskevassa esimerkiss\[ADoubleDot]. (Solut on ajettava, \
jotta m\[ADoubleDot]\[ADoubleDot]ritelm\[ADoubleDot]t tulevat \
voimaan.)\
\>", "Text"],

Cell[BoxData[
    \(euler[f_, x0_, y0_, h_, xend_] := 
      Module[{X, Y, kend}, \[IndentingNewLine]X[0] = 
          x0; \[IndentingNewLine]X[k_] := \(X[k] = 
            X[k - 1] + h\); \[IndentingNewLine]Y[0] = 
          y0; \[IndentingNewLine]Y[k_] := \(Y[k] = 
            Y[k - 1] + 
              h\ f[X[k - 1], Y[k - 1]]\); \[IndentingNewLine]kend = 
          Round[\((xend - x0)\)/h]; \[IndentingNewLine]Table[{X[k], 
            Y[k]}, {k, 0, kend}]]\)], "Input"],

Cell[BoxData[
    \(pareuler[f_, x0_, y0_, h_, xend_] := 
      Module[{X, Y, kend}, \[IndentingNewLine]X[0] = 
          x0; \[IndentingNewLine]X[k_] := \(X[k] = 
            X[k - 1] + h\); \[IndentingNewLine]Y[0] = 
          y0; \[IndentingNewLine]Y[k_] := \(Y[k] = 
            Y[k - 1] + 
              h/2\ \((f[X[k - 1], Y[k - 1]] + 
                    f[X[k], 
                      Y[k - 1] + 
                        h\ f[X[k - 1], 
                            Y[k - 
                                1]]])\)\); \[IndentingNewLine]kend = 
          Round[\((xend - x0)\)/h]; \[IndentingNewLine]Table[{X[k], 
            Y[k]}, {k, 0, kend}]]\)], "Input"],

Cell[BoxData[
    \(rungekutta[f_, x0_, y0_, h_, xend_] := 
      Module[{X, Y, kend}, \[IndentingNewLine]X[0] = 
          x0; \[IndentingNewLine]X[k_] := \(X[k] = 
            X[k - 1] + h\); \[IndentingNewLine]Y[0] = 
          y0; \[IndentingNewLine]Y[k_] := \(Y[k] = 
            Y[k - 1] + 
              1/6\ Module[{k1, k2, k3, k4}, 
                  k1 = h\ f[X[k - 1], 
                        Y[k - 1]]; \[IndentingNewLine]k2 = 
                    h\ f[X[k - 1] + h/2, 
                        Y[k - 1] + k1/2]; \[IndentingNewLine]k3 = 
                    h\ f[X[k - 1] + h/2, 
                        Y[k - 1] + k2/2]; \[IndentingNewLine]k4 = 
                    h\ f[X[k - 1] + h, 
                        Y[k - 1] + k3]; \[IndentingNewLine]k1 + 
                    2\ k2 + 2\ k3 + k4]\); \[IndentingNewLine]kend = 
          Round[\((xend - x0)\)/h]; \[IndentingNewLine]Table[{X[k], 
            Y[k]}, {k, 0, kend}]]\)], "Input"],

Cell[BoxData[
    \(adamsbashforth[f_, x0_, y0_, h_, xend_] := 
      Module[{X, Y, kend}, \[IndentingNewLine]X[0] = 
          x0; \[IndentingNewLine]X[k_] := \(X[k] = 
            X[k - 1] + h\); \[IndentingNewLine]Y[0] = 
          y0; \[IndentingNewLine]Y[k_ /; k <= 3] := \(Y[k] = 
            Y[k - 1] + 
              1/6\ Module[{k1, k2, k3, k4}, 
                  k1 = h\ f[X[k - 1], 
                        Y[k - 1]]; \[IndentingNewLine]k2 = 
                    h\ f[X[k - 1] + h/2, 
                        Y[k - 1] + k1/2]; \[IndentingNewLine]k3 = 
                    h\ f[X[k - 1] + h/2, 
                        Y[k - 1] + k2/2]; \[IndentingNewLine]k4 = 
                    h\ f[X[k - 1] + h, 
                        Y[k - 1] + k3]; \[IndentingNewLine]k1 + 
                    2\ k2 + 2\ k3 + k4]\); \[IndentingNewLine]Y[
            k_ /; k > 3] := \(Y[k] = 
            Y[k - 1] + 
              h/24\ \((55\ f[X[k - 1], Y[k - 1]] - 
                    59\ f[X[k - 2], Y[k - 2]] + 
                    37\ f[X[k - 3], Y[k - 3]] - 
                    9\ f[X[k - 4], 
                        Y[k - 4]])\)\); \[IndentingNewLine]kend = 
          Round[\((xend - x0)\)/h]; \[IndentingNewLine]Table[{X[k], 
            Y[k]}, {k, 0, kend}]]\)], "Input"],

Cell[TextData[{
  "Esimerkkin\[ADoubleDot] olkoon differentiaaliyht\[ADoubleDot]l\
\[ODoubleDot] ",
  Cell[BoxData[
      \(TraditionalForm\`y''\  + \ x\ y\  = \ 0\)]],
  " alkuehtona ",
  Cell[BoxData[
      \(TraditionalForm\`y(0)\  = \ 0\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`y' \((0)\)\  = \ 1\)]],
  ". Kyseess\[ADoubleDot] on Airyn yht\[ADoubleDot]l\[ODoubleDot], \
jossa x-akselin suunta on k\[ADoubleDot]\[ADoubleDot]nnetty, ts. ",
  Cell[BoxData[
      \(TraditionalForm\`x\)]],
  ":n merkki on vaihdettu. \
Yht\[ADoubleDot]l\[ODoubleDot]\[ADoubleDot] vastaava normaaliryhm\
\[ADoubleDot] muodostuu kahdesta yht\[ADoubleDot]l\[ODoubleDot]st\
\[ADoubleDot] ",
  Cell[BoxData[
      \(TraditionalForm\`y'\  = \ z\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`z'\  = \ \(-\ x\)\ y\)]],
  " alkuehtona ",
  Cell[BoxData[
      \(TraditionalForm\`y(0)\  = \ 0\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`z(0)\  = \ 1\)]],
  ". Vektorimuodossa normaaliryhm\[ADoubleDot] on ",
  Cell[BoxData[
      \(TraditionalForm\`Y'\  = \ F(x, Y)\)]],
  "; oikean puolen vektoriarvoinen funktio \
m\[ADoubleDot]\[ADoubleDot]ritell\[ADoubleDot]\[ADoubleDot]n \
Mathematicalle seuraavasti: "
}], "Text"],

Cell[BoxData[
    \(f[x_, {y_, z_}] := {z, \ \(-\ x\)\ y}\)], "Input"],

Cell["Askelpituus ja arvo, jolla alkuehto annetaan:", "Text"],

Cell[BoxData[
    \(h = 0.1\)], "Input"],

Cell[BoxData[
    \(x0 = \ 0\)], "Input"],

Cell[TextData[{
  "Tuntemattomana funktiona on vektori ",
  Cell[BoxData[
      \(TraditionalForm\`Y\  = \ \((y, z)\)\)]],
  ", joten alkuarvo on my\[ODoubleDot]s vektori:"
}], "Text"],

Cell[BoxData[
    \(y0\  = \ {0, 1}\)], "Input"],

Cell[TextData[{
  "Lasketaan v\[ADoubleDot]lill\[ADoubleDot] ",
  Cell[BoxData[
      \(TraditionalForm\`\([0, 10]\)\)]],
  ":"
}], "Text"],

Cell[BoxData[
    \(xend = \ 10\)], "Input"],

Cell[TextData[{
  "Ratkaisufunktion approksimaatio jokaisessa pisteess\[ADoubleDot] \
",
  Cell[BoxData[
      \(TraditionalForm\`x\_k\)]],
  " saadaan kaksikomponenttisena vektorina. Edellinen komponentti on \
itse funktion ",
  Cell[BoxData[
      \(TraditionalForm\`y\)]],
  " arvo, j\[ADoubleDot]lkimm\[ADoubleDot]inen sen derivaatan ",
  Cell[BoxData[
      \(TraditionalForm\`z\  = \ y'\)]],
  " arvo:"
}], "Text"],

Cell[BoxData[{
    \(\(eulerdata = \ 
        euler[f, x0, y0, h, xend];\)\), "\[IndentingNewLine]", 
    \(Short[eulerdata, 10]\)}], "Input"],

Cell[TextData[{
  "Muuttujaan ",
  StyleBox["eulerdata",
    FontFamily->"Courier New"],
  " talletettu tulostus on huomattavan pitk\[ADoubleDot], ja siit\
\[ADoubleDot] on Mathematican ",
  StyleBox["Short",
    FontFamily->"Courier New"],
  "-funktion avulla kirjoitettu n\[ADoubleDot]kyviin vain osa. \
Merkint\[ADoubleDot] ",
  StyleBox["<<...>>",
    FontFamily->"Courier New"],
  " osoittaa, kuinka monta termi\[ADoubleDot] on j\[ADoubleDot]tetty \
pois."
}], "Text"],

Cell[TextData[{
  "T\[ADoubleDot]st\[ADoubleDot] voidaan poimia vain argumentin ",
  Cell[BoxData[
      \(TraditionalForm\`x\)]],
  " ja funktion ",
  Cell[BoxData[
      \(TraditionalForm\`y\)]],
  " arvot sijoituss\[ADoubleDot]\[ADoubleDot]nn\[ODoubleDot]ll\
\[ADoubleDot], mink\[ADoubleDot] j\[ADoubleDot]lkeen voidaan piirt\
\[ADoubleDot]\[ADoubleDot] kuva:"
}], "Text"],

Cell[BoxData[
    \(poiminta = \ {x_, {y_, z_}} :> {x, y}\)], "Input"],

Cell[BoxData[{
    \(\(eulerdata = \ 
        eulerdata /. poiminta;\)\), "\[IndentingNewLine]", 
    \(Short[eulerdata, 10]\)}], "Input"],

Cell[BoxData[
    \(eulerkuva = \ ListPlot[eulerdata]\)], "Input"],

Cell["Vastaavat laskut muita menetelmi\[ADoubleDot] k\[ADoubleDot]ytt\
\[ADoubleDot]en:", "Text"],

Cell[BoxData[{
    \(\(pareulerdata = \ 
        pareuler[f, x0, y0, h, xend] /. 
          poiminta;\)\), "\[IndentingNewLine]", 
    \(Short[pareulerdata, 10]\)}], "Input"],

Cell[BoxData[
    \(pareulerkuva = \ ListPlot[pareulerdata]\)], "Input"],

Cell[BoxData[{
    \(\(rungekuttadata = \ 
        rungekutta[f, x0, y0, h, xend] /. 
          poiminta;\)\), "\[IndentingNewLine]", 
    \(Short[rungekuttadata, 10]\)}], "Input"],

Cell[BoxData[
    \(rungekuttakuva = \ ListPlot[rungekuttadata]\)], "Input"],

Cell[BoxData[{
    \(\(adamsbashforthdata = \ 
        adamsbashforth[f, x0, y0, h, xend] /. 
          poiminta;\)\), "\[IndentingNewLine]", 
    \(Short[adamsbashforthdata, 10]\)}], "Input"],

Cell[BoxData[
    \(adamsbashforthkuva = \ 
      ListPlot[adamsbashforthdata]\)], "Input"],

Cell["\<\
Esimerkkin\[ADoubleDot] oleva alkuarvoprobleema voidaan ratkaista my\
\[ODoubleDot]s tarkasti Airyn funktioiden avulla. Mathematica (versio \
4.1) ei kuitenkaan osaa ratkaista kyseess\[ADoubleDot] olevaa \
normaaliryhm\[ADoubleDot]\[ADoubleDot], joten on tarkasteltava \
alkuper\[ADoubleDot]ist\[ADoubleDot] Airyn yht\[ADoubleDot]l\
\[ODoubleDot]\[ADoubleDot]:\
\>", "Text"],

Cell[BoxData[
    \(tarkkaratkaisu = \ 
      y /. First[
          DSolve[{\(y''\)[x]\  + \ x\ y[x] \[Equal] 0, 
              y[0] \[Equal] 0, \(y'\)[0] \[Equal] 1}, y, 
            x]]\)], "Input"],

Cell[BoxData[
    \(tarkkakuva = \ 
      Plot[tarkkaratkaisu[x], {x, 0, xend}]\)], "Input"],

Cell["\<\
Eri menetelmill\[ADoubleDot] saadut approksimaatiot ja tarkka \
ratkaisu verrattuina:\
\>", "Text"],

Cell[BoxData[
    \(kuva = \ 
      Show[eulerkuva, pareulerkuva, rungekuttakuva, 
        adamsbashforthkuva, tarkkakuva, 
        PlotRange -> All]\)], "Input"],

Cell["\<\
Tarkan ratkaisun tarkkuus riippuu luonnollisesti siit\[ADoubleDot], \
miten Mathematica laskee ratkaisussa esiintyvien Airyn funktioiden ja \
gammafunktion arvot. \
\>", "Text"],

Cell["\<\
Vertailun vuoksi alkuarvoprobleema voidaan ratkaista my\[ODoubleDot]s \
Mathematican k\[ADoubleDot]ytt\[ADoubleDot]m\[ADoubleDot]ll\
\[ADoubleDot] numeerisen ratkaisemisen algoritmilla, joka on edell\
\[ADoubleDot] esitettyj\[ADoubleDot] kehittyneempi:\
\>", "Text"],

Cell[BoxData[
    \(numeerinenratkaisu = 
      y /. First[
          NDSolve[{\(y''\)[x]\  + \ x\ y[x] \[Equal] 0, 
              y[0] \[Equal] 0, \(y'\)[0] \[Equal] 1}, 
            y, {x, x0, xend}]]\)], "Input"],

Cell[TextData[{
  "Tulos on interpolaatiofunktio, jonka arvo v\[ADoubleDot]lin p\
\[ADoubleDot]\[ADoubleDot]tepisteess\[ADoubleDot] voidaan laskea \
tavalliseen tapaan. Eri ratkaisujen antamat arvot loppupisteess\
\[ADoubleDot] ",
  Cell[BoxData[
      \(TraditionalForm\`x\  = \ 10\)]],
  ":"
}], "Text"],

Cell[BoxData[
    \({\(Last[eulerdata]\)[\([2]\)], \(Last[
          pareulerdata]\)[\([2]\)], \(Last[
          rungekuttadata]\)[\([2]\)], \(Last[
          adamsbashforthdata]\)[\([2]\)], tarkkaratkaisu[xend] // N, 
      numeerinenratkaisu[xend]}\)], "Input"]
}, Open  ]],

Cell["SKK 30.04.2001", "Text",
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell["Linkit", "Subtitle"],

Cell["\<\
teoria/numkkl: korkeamman kertaluvun yht\[ADoubleDot]l\[ODoubleDot]n \
numeerinen ratkaiseminen\
\>", "Text"],

Cell["ratk/numeul: Eulerin menetelm\[ADoubleDot]", "Text"],

Cell["\<\
ratk/numheu: parannettu Eulerin menetelm\[ADoubleDot]\
\>", "Text"],

Cell["\<\
ratk/numrgk: Rungen \[Dash] Kuttan menetelm\[ADoubleDot]\
\>", "Text"],

Cell["\<\
ratk/numadb: Adamsin \[Dash] Bashforthin menetelm\[ADoubleDot]\
\>", "Text"],

Cell["teoria/yhmnor: normaaliryhm\[ADoubleDot]", "Text"]
}, Open  ]]
},
FrontEndVersion->"4.1 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
CellGrouping->Manual,
WindowSize->{686, 565},
WindowMargins->{{6, Automatic}, {Automatic, -4}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic}
]
