Notebook[{

Cell[CellGroupData[{
Cell["Differentiaaliyht\[ADoubleDot]l\[ODoubleDot]t", "Section"],

Cell["Esimerkit", "Subsection"],

Cell["Sarjaratkaisut", "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sarjaratkaisun etsiminen Mathematicalla", "Title"],

Cell["\<\
Olkoon tarkasteltavana ensimm\[ADoubleDot]isen kertaluvun \
differentiaaliyht\[ADoubleDot]l\[ODoubleDot]:\
\>", "Text"],

Cell[BoxData[
    \(diffyht = \ \(y'\)[x] == 1\  + \ y[x]^2\)], "Input"],

Cell[TextData[{
  "T\[ADoubleDot]lle pyrit\[ADoubleDot]\[ADoubleDot]n etsim\
\[ADoubleDot]\[ADoubleDot]n sarjaratkaisu origokeskisen\[ADoubleDot] \
potenssisarjana. Tavoitteena on laskea sarjan termien kertoimet ",
  Cell[BoxData[
      \(TraditionalForm\`n\)]],
  "-asteiseen termiin saakka:"
}], "Text"],

Cell[BoxData[
    \(n = 10\)], "Input"],

Cell["Tarvittava potenssisarjamuotoinen yrite j\[ADoubleDot]\
\[ADoubleDot]nn\[ODoubleDot]stermeineen on", "Text"],

Cell[BoxData[
    \(yrite := \ 
      Function[x, 
        Sum[a[k]\ x^k, \ {k, 0, n}]\  + \ 
          O[x]^\((n + 1)\)]\)], "Input"],

Cell["\<\
T\[ADoubleDot]m\[ADoubleDot] on esitetty funktiona eik\[ADoubleDot] \
lausekkeena, jotta yht\[ADoubleDot]l\[ODoubleDot]\[ODoubleDot]n \
sijoitettaessa my\[ODoubleDot]s derivaatta saadaan sijoitetuksi:\
\>", "Text"],

Cell[BoxData[
    \(sarjayht = \ diffyht /. y -> yrite\)], "Input"],

Cell[TextData[{
  "Yht\[ADoubleDot]l\[ODoubleDot]n oikealla ja vasemmalla puolella on \
potenssisarja. Jotta n\[ADoubleDot]m\[ADoubleDot] olisivat samat, \
tulee samakorkuisten potenssien kertoimien yht\[ADoubleDot]l\
\[ODoubleDot]n oikealla ja vasemmalla puolella olla samat. Kertoimien \
v\[ADoubleDot]lille t\[ADoubleDot]ll\[ODoubleDot]in syntyv\
\[ADoubleDot]t yht\[ADoubleDot]l\[ODoubleDot]t voidaan muodostaa \
Mathematican ",
  StyleBox["LogicalExpand",
    FontFamily->"Courier New",
    FontVariations->{"CompatibilityType"->0}],
  "-komennolla. Ensimm\[ADoubleDot]inen \
yht\[ADoubleDot]l\[ODoubleDot] saadaan vertaamalla vakiotermien \
kertoimia, toinen vertaamalla ensimm\[ADoubleDot]isen asteen termej\
\[ADoubleDot] jne."
}], "Text"],

Cell[BoxData[
    \(yhtalot = \ LogicalExpand[sarjayht]\)], "Input"],

Cell[TextData[{
  "Tuloksena on rekursiivinen ep\[ADoubleDot]lineaarinen yht\
\[ADoubleDot]l\[ODoubleDot]ryhm\[ADoubleDot]: \
ensimm\[ADoubleDot]isest\[ADoubleDot] \
yht\[ADoubleDot]l\[ODoubleDot]st\[ADoubleDot] voidaan ratkaista ",
  StyleBox["a[1]",
    FontFamily->"Courier New"],
  ", jos ",
  StyleBox["a[0]",
    FontFamily->"Courier New"],
  " tunnetaan, toisesta t\[ADoubleDot]m\[ADoubleDot]n \
j\[ADoubleDot]lkeen ",
  StyleBox["a[2]",
    FontFamily->"Courier New"],
  ", kolmannesta ",
  StyleBox["a[3]",
    FontFamily->"Courier New"],
  " jne. Kokonaisuudesaan ryhm\[ADoubleDot] voidaan ratkaista ",
  StyleBox["Solve",
    FontFamily->"Courier New",
    FontVariations->{"CompatibilityType"->0}],
  "-komennolla. T\[ADoubleDot]ss\[ADoubleDot] j\[ADoubleDot]lkimm\
\[ADoubleDot]iseksi argumentiksi pit\[ADoubleDot]isi oikeastaan antaa \
lista yht\[ADoubleDot]l\[ODoubleDot]ryhm\[ADoubleDot]n \
tuntemattomista, mutta oletuksena on, ett\[ADoubleDot] ratkaisu \
tapahtuu kaikkien ryhm\[ADoubleDot]ss\[ADoubleDot] esiintyvien \
symbolien suhteen. Kaikkia tuntemattomia ei saada ratkaistuiksi, vaan \
muut voidaan ainoastaan lausua ensimm\[ADoubleDot]isen kertoimen ",
  StyleBox["a[0]",
    FontFamily->"Courier New"],
  " avulla; t\[ADoubleDot]st\[ADoubleDot] annetaan varoitus."
}], "Text"],

Cell[BoxData[
    \(ratk = \ Solve[yhtalot]\)], "Input"],

Cell["\<\
Sijoittamalla kertoimet yritteeseen saadaan ratkaisuna olevan \
potenssisarjan alkup\[ADoubleDot]\[ADoubleDot]:\
\>", "Text"],

Cell[BoxData[
    \(sarjaratk = \ yrite[x] /. First[ratk]\)], "Input"],

Cell[TextData[{
  "T\[ADoubleDot]m\[ADoubleDot] sis\[ADoubleDot]lt\[ADoubleDot]\
\[ADoubleDot] yhden m\[ADoubleDot]\[ADoubleDot]r\[ADoubleDot]\
\[ADoubleDot]m\[ADoubleDot]tt\[ODoubleDot]m\[ADoubleDot]n vakion ",
  StyleBox["a[0]",
    FontFamily->"Courier New"],
  ", kuten ensimm\[ADoubleDot]isen kertaluvun differentiaaliyht\
\[ADoubleDot]l\[ODoubleDot]n yleiselle ratkaisulle luonnollista \
onkin. Jos alkuehdoksi valitaan ",
  Cell[BoxData[
      \(TraditionalForm\`y(0)\  = \ 0\)]],
  ", tulee olla ",
  StyleBox["a[0]",
    FontFamily->"Courier New"],
  " = 0. Vastaava yksitt\[ADoubleDot]isratkaisu on"
}], "Text"],

Cell[BoxData[
    \(yksittratk = \ sarjaratk /. a[0] -> 0\)], "Input"],

Cell[TextData[{
  "T\[ADoubleDot]m\[ADoubleDot] on sama kuin funktion ",
  Cell[BoxData[
      \(TraditionalForm\`tan(x)\)]],
  " origokeskinen Taylorin sarja:"
}], "Text"],

Cell[BoxData[
    \(Series[Tan[x], {x, 0, n}]\)], "Input"],

Cell[TextData[{
  "N\[ADoubleDot]in tulee ollakin, sill\[ADoubleDot] \
differentiaaliyht\[ADoubleDot]l\[ODoubleDot] on separoituva ja sen \
yleiseksi ratkaisuksi saadaan ",
  Cell[BoxData[
      \(TraditionalForm\`y\  = \ tan(x\  + \ C)\)]],
  ":"
}], "Text"],

Cell[BoxData[
    \(DSolve[diffyht, y[x], x]\)], "Input"],

Cell[TextData[{
  "Jotta sarjaratkaisulle voitaisiin piirt\[ADoubleDot]\[ADoubleDot] \
kuvaaja, siit\[ADoubleDot] on pudotettava \
j\[ADoubleDot]\[ADoubleDot]nn\[ODoubleDot]stermi pois. \
T\[ADoubleDot]m\[ADoubleDot]n tarkkaa lausekettahan ei tunneta eik\
\[ADoubleDot] sille siis voida laskea numeerisia arvoja piirt\
\[ADoubleDot]mist\[ADoubleDot] varten. J\[ADoubleDot]\[ADoubleDot]nn\
\[ODoubleDot]stermin poistaminen tapahtuu komennolla ",
  StyleBox["Normal",
    FontFamily->"Courier New",
    FontVariations->{"CompatibilityType"->0}],
  ":"
}], "Text"],

Cell[BoxData[
    \(poly = \ Normal[yksittratk]\)], "Input"],

Cell[TextData[{
  "Sarjaratkaisu ja funktio ",
  Cell[BoxData[
      \(TraditionalForm\`tan\ x\)]],
  " samassa kuvassa:"
}], "Text"],

Cell[BoxData[
    \(Plot[{poly, Tan[x]}, {x, 0, 1.5}]\)], "Input"],

Cell[TextData[{
  "Esitetty lasku ei anna viitteit\[ADoubleDot] sarjaratkaisun \
suppenemisalueesta. Kokonaan muilla keinoilla voidaan osoittaa, ett\
\[ADoubleDot] tangentin origokeskisen Taylorin sarjan suppenemiss\
\[ADoubleDot]de on ",
  Cell[BoxData[
      \(TraditionalForm\`\[Pi]/2\)]],
  ". Sarja suppenee siis vain v\[ADoubleDot]lill\[ADoubleDot] ",
  Cell[BoxData[
      \(TraditionalForm\`\(\(]\) \(\(-\[Pi]\)/
          2\)\), \ \[Pi]/\(\(2\)\([\)\)\)]],
  "."
}], "Text"],

Cell[TextData[{
  "Haluttua termilukua ",
  Cell[BoxData[
      \(TraditionalForm\`n\)]],
  " voidaan edell\[ADoubleDot] olevassa laskussa muuttaa ja t\
\[ADoubleDot]m\[ADoubleDot]n j\[ADoubleDot]lkeen laskea kaikki \
uudelleen valinnalla Evaluate Notebook valikosta Kernel/Evaluation."
}], "Text"]
}, Open  ]],

Cell["SKK 30.04.2001", "Text",
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell["Linkit", "Subtitle"],

Cell["ratk/srjrtk: sarjamuotoinen yrite", "Text"]
}, Open  ]]
},
FrontEndVersion->"4.1 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
CellGrouping->Manual,
WindowSize->{681, 565},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic}
]
