Notebook[{

Cell[CellGroupData[{
Cell["Differentiaaliyht\[ADoubleDot]l\[ODoubleDot]t", "Section"],

Cell["Ratkaiseminen", "Subsection"],

Cell["Ohjelmistojen k\[ADoubleDot]ytt\[ODoubleDot]", "Subsubsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Differentiaaliyht\[ADoubleDot]l\[ODoubleDot]n ratkaiseminen \
Mathematicalla numeerisesti\
\>", "Title"],

Cell[TextData[{
  "Differentiaaliyht\[ADoubleDot]l\[ODoubleDot]n numeerisen \
ratkaisemisen edellytyksen\[ADoubleDot] on, ett\[ADoubleDot] kyseess\
\[ADoubleDot] on ",
  StyleBox["alkuarvoprobleema",
    FontSlant->"Italic"],
  ", ts. annettuna on sek\[ADoubleDot] \
differentiaaliyht\[ADoubleDot]l\[ODoubleDot] ett\[ADoubleDot] \
alkuehto. Etsitt\[ADoubleDot]v\[ADoubleDot] ratkaisu on yksik\
\[ADoubleDot]sitteinen eik\[ADoubleDot] sis\[ADoubleDot]ll\
\[ADoubleDot] m\[ADoubleDot]\[ADoubleDot]r\[ADoubleDot]\[ADoubleDot]m\
\[ADoubleDot]tt\[ODoubleDot]mi\[ADoubleDot] vakioita."
}], "Text"],

Cell[TextData[{
  "Tarkoitusta varten on ",
  StyleBox["NDSolve",
    FontFamily->"Courier New"],
  "-komento, jonka syntaksi on hyvin samanlainen kuin algebrallisen \
ratkaisemisen ",
  StyleBox["DSolve",
    FontFamily->"Courier New"],
  "-komennon. Ainoana erona on, ett\[ADoubleDot] viimeisess\
\[ADoubleDot] argumentissa on annettava my\[ODoubleDot]s muuttujan ",
  Cell[BoxData[
      \(TraditionalForm\`x\)]],
  " v\[ADoubleDot]li, jolla ratkaisua \
etsit\[ADoubleDot]\[ADoubleDot]n. Ratkaisu on mahdollista saada \
lausekkeen tai funktion muodossa."
}], "Text"],

Cell[CellGroupData[{

Cell["Ratkaisu lausekkeena", "Subtitle"],

Cell[BoxData[
    \(diffyht = \ \(y'\)[x]\  == \ x^2\  - \ y[x]^2\)], "Input"],

Cell[BoxData[
    \(alkuehto = \ y[0]\  == \ 1\)], "Input"],

Cell[BoxData[
    \(ratkaisulauseke = \ 
      NDSolve[{diffyht, alkuehto}, y[x], {x, 0, 5}]\)], "Input"],

Cell[BoxData[
    \(ylauseke = \ y[x] /. First[ratkaisulauseke]\)], "Input"],

Cell[TextData[{
  "Ratkaisu saadaan tarkkaa ratkaisua approksimoivana \
interpolaatiofunktiona. Hieman erikoisesta esitystavasta huolimatta t\
\[ADoubleDot]m\[ADoubleDot] on kuin mik\[ADoubleDot] tahansa \
muuttujan ",
  Cell[BoxData[
      \(TraditionalForm\`x\)]],
  " sis\[ADoubleDot]lt\[ADoubleDot]v\[ADoubleDot] lauseke:"
}], "Text"],

Cell[BoxData[
    \(ylauseke /. x -> 0.8\)], "Input"],

Cell[BoxData[
    \(derivlauseke = \ D[ylauseke, x]\)], "Input"],

Cell[BoxData[
    \(derivlauseke /. x -> 0.8\)], "Input"],

Cell[BoxData[
    \(Plot[ylauseke, {x, 0, 5}, 
      AspectRatio -> Automatic]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Ratkaisu funktiona", "Subtitle"],

Cell[BoxData[
    \(ratkaisufunktio = \ 
      NDSolve[{diffyht, alkuehto}, y, {x, 0, 5}]\)], "Input"],

Cell[BoxData[
    \(y0 = \ y /. First[ratkaisufunktio]\)], "Input"],

Cell["Kyseess\[ADoubleDot] on aito funktio:", "Text"],

Cell[BoxData[
    \(y0[0.8]\)], "Input"],

Cell[BoxData[
    \(\(y0'\)[0.8]\)], "Input"],

Cell[BoxData[
    \(Integrate[y0[x], {x, 0, 5}]\)], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["NDSolve",
    FontFamily->"Courier New"],
  " ja ",
  StyleBox["InterpolatingFunction",
    FontFamily->"Courier New",
    FontVariations->{"CompatibilityType"->0}]
}], "Subtitle"],

Cell[TextData[{
  "Mathematican funktio ",
  StyleBox["NDSolve",
    FontFamily->"Courier New"],
  " k\[ADoubleDot]ytt\[ADoubleDot]\[ADoubleDot] alkuarvoprobleeman \
numeeriseen ratkaisemiseen erilaisia numeerisia algoritmeja yht\
\[ADoubleDot]l\[ODoubleDot]st\[ADoubleDot] riippuen. \
N\[ADoubleDot]iden avulla saadaan ratkaisufunktion arvoille \
approksimaatiot ",
  Cell[BoxData[
      \(TraditionalForm\`y\_k\)]],
  " sopivasti valituissa pisteiss\[ADoubleDot] ",
  Cell[BoxData[
      \(TraditionalForm\`x\_k\)]],
  "."
}], "Text"],

Cell[TextData[{
  "Elementti ",
  StyleBox["InterpolatingFunction",
    FontFamily->"Courier New"],
  " on interpoloiva funktio, joka perustuu Lagrangen ja Hermiten \
interpolaatiopolynomeihin. N\[ADoubleDot]iden laskeminen pohjautuu  \
ratkaisua approksimoivaan pisteist\[ODoubleDot]\[ODoubleDot]n ",
  Cell[BoxData[
      \(TraditionalForm\`\((x\_k, y\_k)\)\)]],
  ". Tarkemman k\[ADoubleDot]sityksen interpoloivan funktion sis\
\[ADoubleDot]lt\[ADoubleDot]m\[ADoubleDot]st\[ADoubleDot] \
informaatiosta saa komennolla ",
  StyleBox["FullForm",
    FontFamily->"Courier New"],
  ":"
}], "Text"],

Cell[BoxData[
    \(\(ylauseke // FullForm;\)\)], "Input"],

Cell["\<\
T\[ADoubleDot]m\[ADoubleDot]n tulostus on huomattavan pitk\
\[ADoubleDot]. Sen saa n\[ADoubleDot]kyviin poistamalla puolipisteen \
edell\[ADoubleDot] olevan sy\[ODoubleDot]tteen lopusta ja ajamalla sy\
\[ODoubleDot]tteen uudelleen.\
\>", "Text"]
}, Open  ]]
}, Open  ]],

Cell["SKK 30.04.2001", "Text",
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell["Linkit", "Subtitle"],

Cell["teoria/perrtk: yleinen ja yksitt\[ADoubleDot]isratkaisu", \
"Text"],

Cell["teoria/peralk: alkuehto", "Text"],

Cell["teoria/numper: numeerisen ratkaisemisen perusidea", "Text"],

Cell["ratk/symalg: ratkaiseminen Mathematicalla algebrallisesti", \
"Text"]
}, Open  ]]
},
FrontEndVersion->"4.1 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
CellGrouping->Manual,
WindowSize->{602, 599},
WindowMargins->{{181, Automatic}, {Automatic, 8}},
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
CellLabelAutoDelete->True
]
